"use strict";function _interopDefault(ex){return ex&&"object"==typeof ex&&"default"in ex?ex.default:ex}Object.defineProperty(exports,"__esModule",{value:!0});var tempy=require("tempy"),execa=_interopDefault(require("execa")),semver=require("semver"),normalizeUrl=_interopDefault(require("normalize-url")),path=require("path"),path__default=_interopDefault(path),rc=_interopDefault(require("rc")),getAuthToken=_interopDefault(require("registry-auth-token")),getRegistryUrl=_interopDefault(require("registry-auth-token/registry-url")),fsExtra=require("fs-extra"),nerfDart=_interopDefault(require("nerf-dart")),SemanticReleaseError=_interopDefault(require("@semantic-release/error")),readPkg=_interopDefault(require("read-pkg")),glob=_interopDefault(require("globby")),AggregateError=_interopDefault(require("aggregate-error")),lodash=require("lodash");const[homepage$1]="https://github.com/jdalrymple/semantic-release-npmx#readme".split("#"),linkify=file=>`${homepage$1}/blob/master/${file}`,ERROR_DEFINITIONS={EINVALIDNPMPUBLISH:({npmPublish:npmPublish})=>({message:"Invalid `npmPublish` option.",details:`The [npmPublish option](${linkify("README.md#npmpublish")}) option, if defined, must be a \`Boolean\`.\n\nYour configuration for the \`npmPublish\` option is \`${npmPublish}\`.`}),EINVALIDTARBALLDIR:({tarballDir:tarballDir})=>({message:"Invalid `tarballDir` option.",details:`The [tarballDir option](${linkify("README.md#tarballdir")}) option, if defined, must be a \`String\`.\n\nYour configuration for the \`tarballDir\` option is \`${tarballDir}\`.`}),EINVALIDPKGROOT:({pkgRoot:pkgRoot})=>({message:"Invalid `pkgRoot` option.",details:`The [pkgRoot option](${linkify("README.md#pkgroot")}) option, if defined, must be a \`String\`.\n\nYour configuration for the \`pkgRoot\` option is \`${pkgRoot}\`.`}),ENONPMTOKEN:({registry:registry})=>({message:"No npm token specified.",details:`An [npm token](${linkify("README.md#npm-registry-authentication")}) must be created and set in the \`NPM_TOKEN\` environment variable on your CI environment.\n\nPlease make sure to create an [npm token](https://docs.npmjs.com/getting-started/working_with_tokens#how-to-create-new-tokens) and to set it in the \`NPM_TOKEN\` environment variable on your CI environment. The token must allow to publish to the registry \`${registry}\`.`}),EINVALIDNPMTOKEN:({registry:registry})=>({message:"Invalid npm token.",details:`The [npm token](${linkify("README.md#npm-registry-authentication")}) configured in the \`NPM_TOKEN\` environment variable must be a valid [token](https://docs.npmjs.com/getting-started/working_with_tokens) allowing to publish to the registry \`${registry}\`.\n\nIf you are using Two-Factor Authentication, make configure the \`auth-only\` [level](https://docs.npmjs.com/getting-started/using-two-factor-authentication#levels-of-authentication) is supported. **semantic-release** cannot publish with the default \`auth-and-writes\` level.\n\nPlease make sure to set the \`NPM_TOKEN\` environment variable in your CI with the exact value of the npm token.`}),ENOPKGNAME:()=>({message:"Missing `name` property in `package.json`.",details:"The `package.json`'s [name](https://docs.npmjs.com/files/package.json#name) property is required in order to publish a package to the npm registry.\n\nPlease make sure to add a valid `name` for your package in your `package.json`."}),ENOPKG:()=>({message:"Missing `package.json` file.",details:"A [package.json file](https://docs.npmjs.com/files/package.json) at the root of your project is required to release on npm.\n\nPlease follow the [npm guideline](https://docs.npmjs.com/getting-started/creating-node-modules) to create a valid `package.json` file."})};function getError(code,ctx={}){const{message:message,details:details}=ERROR_DEFINITIONS[code](ctx);return new SemanticReleaseError(message,code,details)}const NPMX_DEFAULT_NPM_REGISTRY="https://registry.npmjs.org/";function getReleasesInfo({name:name},{env:{DEFAULT_NPM_REGISTRY:DEFAULT_NPM_REGISTRY=NPMX_DEFAULT_NPM_REGISTRY}={},nextRelease:{version:version}},distTag,registry){return{name:`npm package (@${distTag} dist-tag)`,url:normalizeUrl(registry)===normalizeUrl(DEFAULT_NPM_REGISTRY)?`https://www.npmjs.com/package/${name}/v/${version}`:void 0,channel:distTag}}function getRegistry({publishConfig:{registry:registry}={},name:name},{cwd:cwd=".",env:env={}}={}){return registry||env.NPM_CONFIG_REGISTRY||getRegistryUrl(name.split("/")[0],rc("npm",{registry:NPMX_DEFAULT_NPM_REGISTRY},{config:path__default.resolve(cwd,".npmrc")}))}async function verifyNpmAuth(npmrc,context,pkg){const{cwd:cwd,stdout:stdout,stderr:stderr,env:env={DEFAULT_NPM_REGISTRY:NPMX_DEFAULT_NPM_REGISTRY,...context.env}}=context,registry=getRegistry(pkg,context);if(await async function(npmrc,registry,{cwd:cwd=".",env:{NPM_TOKEN:NPM_TOKEN,NPM_EMAIL:NPM_EMAIL,NPM_CONFIG_USERCONFIG:NPM_CONFIG_USERCONFIG,LEGACY_TOKEN:LEGACY_TOKEN}={},logger:logger}){logger.log("Verify authentication for registry %s",registry);const{configs:configs,...rcConfig}=rc("npm",{registry:NPMX_DEFAULT_NPM_REGISTRY},{config:NPM_CONFIG_USERCONFIG||path__default.resolve(cwd,".npmrc")});let currentConfig="";if(configs.length>0&&(logger.log("Reading npm config from %s",configs.join(", ")),currentConfig=await Promise.all(configs.map(c=>fsExtra.readFile(c))),currentConfig=`${currentConfig.join("\n")}\n`),getAuthToken(registry,{npmrc:rcConfig,recursive:!0}))await fsExtra.outputFile(npmrc,currentConfig.trim());else if(LEGACY_TOKEN&&NPM_EMAIL)await fsExtra.outputFile(npmrc,`${currentConfig}_auth = \${LEGACY_TOKEN}\nemail = \${NPM_EMAIL}`),logger.log(`Wrote NPM_USERNAME, NPM_PASSWORD and NPM_EMAIL to ${npmrc}`);else{if(!NPM_TOKEN)throw getError("ENONPMTOKEN",{registry:registry});await fsExtra.outputFile(npmrc,`${currentConfig}${nerfDart(registry)}:_authToken = \${NPM_TOKEN}`),logger.log(`Wrote NPM_TOKEN to ${npmrc}`)}}(npmrc,registry,context),env.DEFAULT_NPM_REGISTRY&&normalizeUrl(registry)===normalizeUrl(env.DEFAULT_NPM_REGISTRY))try{const whoamiResult=execa("npm",["whoami","--userconfig",npmrc,"--registry",registry],{cwd:cwd,env:env});whoamiResult.stdout.pipe(stdout,{end:!1}),whoamiResult.stderr.pipe(stderr,{end:!1}),await whoamiResult}catch(e){throw getError("EINVALIDNPMTOKEN",{registry:registry})}}function summarizeReleasesInfo(releasesInfo){const validReleases=releasesInfo.filter(i=>!1!==i),urls=validReleases.filter(i=>void 0!==i.url).map(i=>i.url);return 0!==validReleases.length&&{name:validReleases[0].name,urls:urls,channel:validReleases[0].channel}}function getChannel(channel){return channel?semver.validRange(channel)?`release-${channel}`:channel:"latest"}async function prepareNpm(npmrc,{cwd:cwd,env:env,stdout:stdout,stderr:stderr,nextRelease:{version:version},logger:logger},{pkgRoot:pkgRoot,tarballDir:tarballDir}={}){const basePath=pkgRoot?path.resolve(cwd,pkgRoot):cwd;await async function(npmrc,basePath,{env:env,stdout:stdout,stderr:stderr,version:version,logger:logger}){logger.log("Write version %s to package.json in %s",version,basePath);const versionResult=execa("npm",["version",version,"--userconfig",npmrc,"--no-git-tag-version","--allow-same-version"],{cwd:basePath,env:env});versionResult.stdout.pipe(stdout,{end:!1}),versionResult.stderr.pipe(stderr,{end:!1}),await versionResult}(npmrc,basePath,{env:env,stdout:stdout,stderr:stderr,version:version,logger:logger}),tarballDir&&await async function(npmrc,basePath,{cwd:cwd,env:env,stdout:stdout,stderr:stderr,version:version,logger:logger},{tarballDir:tarballDir}={}){logger.log("Creating npm package version %s",version);const packResult=execa("npm",["pack",basePath,"--userconfig",npmrc],{cwd:cwd,env:env});packResult.stdout.pipe(stdout,{end:!1}),packResult.stderr.pipe(stderr,{end:!1});const tarball=(await packResult).stdout.split("\n").pop(),tarballSource=path.resolve(cwd,tarball),tarballDestination=path.resolve(cwd,tarballDir.trim(),tarball);tarballSource!==tarballDestination&&await fsExtra.move(tarballSource,tarballDestination)}(npmrc,basePath,{cwd:cwd,env:env,stdout:stdout,stderr:stderr,version:version,logger:logger},{tarballDir:tarballDir})}async function getPkgInfo(cwd){let pkg;try{pkg=await readPkg({cwd:cwd})}catch(error){if("ENOENT"===error.code)throw getError("ENOPKG");throw error}if(!pkg.private&&!pkg.name)throw getError("ENOPKGNAME");return{...pkg,path:cwd}}async function getAllPkgInfo({cwd:cwd},{pkgRoot:pkgRoot}={}){const rootPath=pkgRoot?path__default.resolve(cwd,String(pkgRoot)):cwd,pkg=await getPkgInfo(rootPath);let subPkgs=[];if(pkg.private){const subpkgsConfig=pkg.workspaces||(await async function(){let file;try{file=await fsExtra.readJson("lerna.json")}catch(e){file={}}return file}()).packages||[];if(subpkgsConfig.length>0){let paths=await Promise.all(subpkgsConfig.map(g=>glob(g,{cwd:cwd,onlyFiles:!1})));paths=paths.flat(),subPkgs=await Promise.all(paths.map(p=>getPkgInfo(path__default.resolve(cwd,p))))}}return{rootPkg:pkg,subPkgs:subPkgs}}function validate({npmPublish:npmPublish,tarballDir:tarballDir,pkgRoot:pkgRoot}){const isNonEmptyString=value=>lodash.isString(value)&&value.trim(),VALIDATORS={npmPublish:lodash.isBoolean,tarballDir:isNonEmptyString,pkgRoot:isNonEmptyString};return Object.entries({npmPublish:npmPublish,tarballDir:tarballDir,pkgRoot:pkgRoot}).reduce((errors,[option,value])=>lodash.isNil(value)||VALIDATORS[option](value)?errors:[...errors,getError(`EINVALID${option.toUpperCase()}`,{[option]:value})],[])}async function verifyNpm(npmrc,context,pluginConfig={}){!function(pluginConfig){const errors=[];if(pluginConfig.default?Object.values(pluginConfig).forEach(c=>errors.push(...validate(c))):errors.push(...validate(pluginConfig)),errors.length>0)throw new AggregateError(errors)}(pluginConfig);const{rootPkg:rootPkg,subPkgs:subPkgs}=await getAllPkgInfo(context,pluginConfig);(function({rootPkg:rootPkg,subPkgs:subPkgs},pluginConfig={}){return!rootPkg.private||subPkgs.some(s=>!s.private)||pluginConfig.npmPublish||Object.values(pluginConfig).some(c=>c.npmPublish)})({rootPkg:rootPkg,subPkgs:subPkgs},pluginConfig)&&await verifyNpmAuth(npmrc,context,rootPkg)}const npmrc=tempy.file({name:".npmrc"}),status={verified:!1,prepared:!1};function modifyContext(context){const env={...function({NPM_EMAIL:NPM_EMAIL,NPM_PASSWORD:NPM_PASSWORD,NPM_USERNAME:NPM_USERNAME}={}){return NPM_USERNAME&&NPM_PASSWORD&&NPM_EMAIL?{LEGACY_TOKEN:Buffer.from(`${NPM_USERNAME}:${NPM_PASSWORD}`,"utf8").toString("base64")}:{}}(context.env),...context.env};return{...context,env:env}}async function verifyConditions(pluginConfig={},context={}){const ctx=modifyContext(context);await verifyNpm(npmrc,ctx,pluginConfig),status.verified=!0}async function prepare(pluginConfig={},context={}){const ctx=modifyContext(context);status.verified||await verifyConditions(pluginConfig,ctx);const{rootPkg:rootPkg,subPkgs:subPkgs}=await getAllPkgInfo(ctx,pluginConfig);await Promise.all([rootPkg,...subPkgs].map(p=>{const{pkgRoot:pkgRoot,...config}=pluginConfig[p.name]||pluginConfig.default||pluginConfig;return prepareNpm(npmrc,ctx,{pkgRoot:p.path,...config},p.private)})),status.prepared=!0}exports.addChannel=async function(pluginConfig={},context={}){const ctx=modifyContext(context);status.verified||await verifyConditions(pluginConfig,ctx);const{rootPkg:rootPkg,subPkgs:subPkgs}=await getAllPkgInfo(ctx,pluginConfig);return summarizeReleasesInfo(await Promise.all([rootPkg,...subPkgs].map(p=>{const{pkgRoot:pkgRoot,...config}=pluginConfig[p.name]||pluginConfig.default||pluginConfig;return async function(npmrc,context={},{npmPublish:npmPublish}={},pkgJson={}){const{cwd:cwd,env:env,stdout:stdout,stderr:stderr,nextRelease:{version:version,channel:channel}={},logger:logger}=context;if(!1===npmPublish||!0===pkgJson.private)return logger.log(`Skip adding to npm channel as ${!1===npmPublish?"npmPublish":"package.json's private property"} is ${!1!==npmPublish}`),!1;const registry=getRegistry(pkgJson,context),distTag=getChannel(channel);logger.log(`Adding version ${version} to npm registry on dist-tag ${distTag}`);const result=execa("npm",["dist-tag","add",`${pkgJson.name}@${version}`,distTag,"--userconfig",npmrc,"--registry",registry],{cwd:cwd,env:env});return result.stdout.pipe(stdout,{end:!1}),result.stderr.pipe(stderr,{end:!1}),await result,logger.log(`Added ${pkgJson.name}@${version} to dist-tag @${distTag} on ${registry}`),getReleasesInfo(pkgJson,context,distTag,registry)}(npmrc,ctx,{pkgRoot:p.path,...config},p)})))},exports.prepare=prepare,exports.publish=async function(pluginConfig,context){const ctx=modifyContext(context);status.prepared||await prepare(pluginConfig,ctx);const{rootPkg:rootPkg,subPkgs:subPkgs}=await getAllPkgInfo(ctx,pluginConfig);return summarizeReleasesInfo(await Promise.all([rootPkg,...subPkgs].map(p=>{const{pkgRoot:pkgRoot,...config}=pluginConfig[p.name]||pluginConfig.default||pluginConfig;return async function(npmrc,context,{npmPublish:npmPublish,pkgRoot:pkgRoot},pkgJson){const{cwd:cwd,env:env,stdout:stdout,stderr:stderr,nextRelease:{version:version,channel:channel}={},logger:logger}=context;if(!1===npmPublish||!0===pkgJson.private)return logger.log(`Skip publishing to npm registry as ${!1===npmPublish?"npmPublish":"package.json's private property"} is ${!1!==npmPublish}`),!1;const basePath=pkgRoot?path.resolve(cwd,pkgRoot):cwd,registry=getRegistry(pkgJson,context),distTag=getChannel(channel);logger.log(`Publishing ${pkgJson.name} version ${version} to npm registry on dist-tag ${distTag}`);const result=execa("npm",["publish",basePath,"--userconfig",npmrc,"--tag",distTag,"--registry",registry],{cwd:cwd,env:env});return result.stdout.pipe(stdout,{end:!1}),result.stderr.pipe(stderr,{end:!1}),await result,logger.log(`Published ${pkgJson.name}@${version} to dist-tag @${distTag} on ${registry}`),getReleasesInfo(pkgJson,context,distTag,registry)}(npmrc,ctx,{pkgRoot:p.path,...config},p)})))},exports.status=status,exports.verifyConditions=verifyConditions;
